package ncsa.util;

import java.io.*;
import java.awt.Component;
import java.awt.Image;
import java.awt.image.ImageObserver;
import java.awt.image.ColorModel;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;

public class ImageHandler {
	Image img = null;
	int[] pixels = null;
	int width;
	int height;

	public ImageHandler() {
	}

	public ImageHandler(Image img, int width, int height) {
		this.img = img;
		this.width = width;
		this.height = height;
	}

        BufferedOutputStream openFile(String file) {
               BufferedOutputStream bos = null;
	
                try {
                        FileOutputStream fos = new FileOutputStream(file);
                        bos = new BufferedOutputStream(fos,
10240);
                } catch (IOException e) {
                        // replace with dialog?
                        System.out.println("Couldn't write file");
                        return null;
                }
                return bos;
        }
	
	public void readPixels() {
		pixels = new int[width*height];
		PixelGrabber pg = new PixelGrabber(img, 0, 0, width, height, pixels, 0, width);

		try {
			pg.grabPixels(0);
		} catch (InterruptedException e) {
			System.err.println("interrupted waiting for pixels!");
			return;
		}

		if ((pg.status() & ImageObserver.ABORT) != 0) {
			System.err.println("image fetch aborted or errored");
			return;
		}

	}

	public final Image getImage() {
		return img;
	}

	public void setImage(Image img) {
		this.img = img;
	}

	public final int getWidth() {
		return width;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public final int getHeight() {
		return height;
	}

	public void setHeight(int height) {
		this.height = height;
	}

	public final int[] getPixels() {
		return pixels;
	}

	public void setPixels(int[] pixels) {
		this.pixels = pixels;
	}

	public Image createImage(Component c) {
		ColorModel cm = ColorModel.getRGBdefault();
		img = c.createImage(new
				MemoryImageSource(width, height, cm,
					pixels, 0, width));
		return img;
	}
}
