/*
 * NCSA Habanero Project
 * Software Development Group
 * National Center for Supercomputing Applications
 * University of Illinois at Urbana-Champaign
 * 605 E. Springfield, Champaign, IL 61820
 *  
 * info@havefun.ncsa.uiuc.edu
 *  
 * Copyright 1995-1996, Board of Trustees of the University of Illinois, 
 * All Rights Reserved
 *  
 * NCSA Habanero software, binary, Java-bytecode, and source (hereafter,
 * Software) is copyrighted by The Board of Trustees of the University of
 * Illinois (UI), and ownership remains with the UI.
 *  
 * The UI grants you (hereafter, Licensee) a license to use the Software for
 * academic, research and internal business purposes only, without a fee.
 * Licensee may distribute the binary and source code (if released) to third
 * parties provided that the copyright notice and this statement appears on
 * all copies and that no charge is associated with such copies.
 *  
 * Licensee may make derivative works.  However, if Licensee distributes any
 * derivative work based on or derived from the Software, then Licensee will
 * (1) notify NCSA regarding its distributing of the derivative work, and (2)
 * clearly notify users that such derivative work is a modified version and
 * not the original NCSA Habanero distributed by the UI.
 *  
 * Any Licensee wishing to make commercial use of the Software should contact
 * the UI, c/o NCSA, to negotiate an appropriate license for such commercial
 * use.  Commercial use included (1) integration of all or part of the
 * Software into a product for sale or license by or on behalf of Licensee to
 * third parties, or (2) distribution of the Software to third parties that
 * need it to utilize a commercial product sold or licensed by or on behalf of
 * Licensee.
 *  
 * UI MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.  THE
 * UI SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY THE USERS OF THIS
 * SOFTWARE.
 *  
 * By using or copying this Software, Licensee agrees to abide by the
 * copyright law and all other applicable laws of the U.S. including, but not
 * limited to, export control laws, and the terms of this license.  UI shall
 * have the right to terminate this license immediately by written notice upon
 * Licensee's breach of, or non-compliance with, any of its terms.  Licensee
 * may be held legally responsible for any copyright infringement that is
 * caused or encouraged by Licensee's failure to abide by the terms of this
 * license.
 * 
 *
 * ----
 * 
 * 
 * U.S. GOVERNMENT RESTRICTED RIGHTS
 * 
 * The Software and/or user documentation are provided with RESTRICTED AND
 * LIMITED RIGHTS.  Use, duplication or disclosure by or to the United States
 * government shall be subject to restrictions as set forth in subparagraph
 * (c)(1)(ii) of Defense Federal Acquisition Regulations Supplement (DFARS)
 * Section 252.227-7013 for Department of Defense contracts and as set forth
 * in Federal Acquisition Regulations (FAR) Section 52.227-19 for civilian
 * agency contracts or any successor regulations.  Contractor/Manufacturer is
 * The Board of Trustees of the University of Illinois, Urbana, Illinois
 * 61801.
 * 
 */
package VotingTool;
import ncsa.env.widget.*;
import java.awt.*;
import java.io.*;
import ncsa.habanero.*;

public class InitVote extends GridPanel{

CheckboxGroup cbg13 = new  CheckboxGroup() ;
CheckboxGroup cbg1;
Checkbox cb131 = new Checkbox("Multiple Answers", cbg13,false );
Checkbox cb132 = new Checkbox("Single Answer", cbg13,true );
Checkbox cb13;
String TypeOfVote;

Button InitVote, Cancel, ListAdd, ListRemove;

TextArea QuestionTextF;
ncsa.awt.LabeledTextField AF;
SelectedList AList ;
Session aSession;
String Topic="", SessionOwner;
String RespArray[];
boolean MultipleAnswers = false;
String DisplayResult="EO";
int VoteType = 1;
boolean Public = true;
GridBagLayout gridbag = new GridBagLayout();


////////////////////////


public InitVote(String Owner){
  
  SessionOwner = Owner;
  
  // Initf = new Frame();
  
  QuestionTextF= new TextArea(4,30);
  
  setBackground(Color.white);
  this.setLayout(gridbag);
  constrain(this, QuestionTextF, 2, 0, 30, 2);
  constrain(this, new Label("QUESTION: "), 0,0,1,1);
  constrain(this, new Label("Answering Mode: "), 0,3,2,1);
  cbg1 = new  CheckboxGroup();
  CheckboxGroup cbg2 = new  CheckboxGroup();
  CheckboxGroup cbg3 = new  CheckboxGroup();
  
  Checkbox cb11 = new Checkbox("Yes/No", cbg1, true);
  constrain(this, cb11,2,4,1,1);
  Checkbox cb12 = new Checkbox("%", cbg1, false);
  constrain(this, cb12, 2,5,1,1);
  cb13 = new Checkbox("Quizz", cbg1, false);
  constrain(this, cb13, 2,6,1,1);
  cb131.disable();
  cb132.disable();
  
  AList = new SelectedList(5, true);
  constrain(this,AList,5,7,5,3);
  AF = new ncsa.awt.LabeledTextField("Answer: ",10);
  constrain(this,AF,3,7,2,1 );
  ListAdd = new Button("Add");
  ListAdd.disable();
  constrain(this,ListAdd,3,8,1,1 );
  ListRemove = new Button("Remove");
  ListRemove.disable();
  constrain(this,ListRemove,4,8,1,1 );
  constrain(this,cb131,3,10,2,1 );
  constrain(this,cb132,3,11,2,1 );
  
  constrain(this,new Label("Vote Display:"),0,13,2,1);
  Checkbox cb21 = new Checkbox("Owner Only", cbg2, false);
  cb21.disable();
  constrain(this,cb21, 2,14,2,1);
  Checkbox cb22 = new Checkbox("Every One", cbg2, true);
  constrain(this,cb22, 2,15,2,1);
  constrain(this,new Label("Access: "),0,17,1,1);
  Checkbox cb31 = new Checkbox("public", cbg3, true);
  constrain(this,cb31, 2,18,2,1);  add(cb31);
  Checkbox cb32 = new Checkbox("secret", cbg3, false);
  constrain(this,cb32, 2,19,2,1);
  
  InitVote = new Button("Init Vote");
  constrain(this,InitVote, 1,21,1,1);
  Cancel = new Button("Cancel");
  constrain(this,Cancel, 5,21,1,1);
  
}

private void DisplayErrorF(String Message){
  new VotingErrorFrame(Message);
}
private boolean QuizzSelected(){
  return cb13.getState();
}
public boolean handleEvent(Event e){
Event ac;
switch (e.id){
 case Event.ACTION_EVENT:

 if (e.target instanceof Button){
   Button BT = (Button)e.target;
   String label=BT.getLabel();
   if (label.equals("Init Vote")) {
     Topic = QuestionTextF.getText();
     if (Topic.equals("")){
       //System.out.println("InitVote: No Topic Given");
       DisplayErrorF("Cannot go on without a Topic...");
       return true;
     }
     if (QuizzSelected()){
       if (AList.countItems()>0){
	 int Nbr = AList.countItems();
	 RespArray =new String [Nbr];
	 for (int i=0; i<Nbr; i++){
	   RespArray[i] = AList.getItem(i);
	   }
       }else {
	 DisplayErrorF("Could you propose some possible Answers ??");
	 //System.out.println("Possible Answers are Missing");
	 return true;
       }
     }
     switch (VoteType){
     case 1: 
       SimpleBallot sb = new SimpleBallot(Topic,Public,SessionOwner, DisplayResult);
       ac = 
	 new Event(this, Event.ACTION_EVENT,sb );
       postEvent(ac);
       //System.out.println("InitVote: handleEvent: Simple Ballot");
       //sb.toDetail();
       break;
     case 2:
       PropBallot pb = new PropBallot(Topic,Public,SessionOwner, DisplayResult);
       ac =  new Event(this, Event.ACTION_EVENT,pb );
       postEvent(ac);
       //System.out.println("InitVote: handleEvent: Prop Ballot");
       //pb.toDetail();
       break;
     case 3:	
       MultiBallot mb = new MultiBallot(Topic,Public,SessionOwner, DisplayResult, RespArray, MultipleAnswers) ;
       ac =  new Event(this, Event.ACTION_EVENT,mb);
       postEvent(ac);
       //System.out.println("InitVote: handleEvent: Multi Ballot");
       //mb.toDetail();
	break;
     }
     return false;
   }
   if (label.equals("Cancel")){
     e.id = HabaneroEvent.QUIT_APP;
    // ac =  new Event(this, Event.ACTION_EVENT, "Cancel");
    // postEvent(ac);
     return false;
   }
   
   if (label.equals("Add")){
     String TempS = AF.getText();
     if (TempS.equals("")){}
     else {
       AList.addItem(TempS);
       AF.setText("");
     }
     return true;
   }
   if (label.equals("Remove")){
     if (AList.getSelectedIndex()== -1){}
     else{AList.delItem(AList.getSelectedIndex());}
     return true;
   }
 }
 if (e.target instanceof Checkbox){
   Checkbox CBS= (Checkbox) e.target;
   if (QuizzSelected()){
     VoteType= 3;
     cb131.enable();
     cb132.enable();
     ListAdd.enable();
     ListRemove.enable();
   }else if (CBS.getCheckboxGroup().equals(cbg1)){
     cb131.disable();
     cb132.disable();
     ListAdd.disable();
     ListRemove.disable();
   }
   if (CBS.getLabel().equals("Multiple Answers")) MultipleAnswers = true;
   if (CBS.getLabel().equals("Single Answer")) MultipleAnswers = false;
   if (CBS.getLabel().equals("Owner Only"))DisplayResult = "OwnerOnly";
   if (CBS.getLabel().equals("Every One")) DisplayResult = "EO";
   if (CBS.getLabel().equals("secret")) Public = false;
   if (CBS.getLabel().equals("public")) Public = true;
   if (CBS.getLabel().equals("Yes/No")) VoteType = 1;
   if (CBS.getLabel().equals("%")) VoteType = 2;
   return true;
 }
 else return false;

default:
 return false;
}
}
public  boolean selected(Event evt, int index, String item) {
   AF.setText(item);
   return true;
 }
public boolean deselected(Event evt, int index) {
   return true;
 }

}



