/*
 * NCSA Habanero Project
 * Software Development Group
 * National Center for Supercomputing Applications
 * University of Illinois at Urbana-Champaign
 * 605 E. Springfield, Champaign, IL 61820
 *  
 * info@havefun.ncsa.uiuc.edu
 *  
 * Copyright 1995-1996, Board of Trustees of the University of Illinois, 
 * All Rights Reserved
 *  
 * NCSA Habanero software, binary, Java-bytecode, and source (hereafter,
 * Software) is copyrighted by The Board of Trustees of the University of
 * Illinois (UI), and ownership remains with the UI.
 *  
 * The UI grants you (hereafter, Licensee) a license to use the Software for
 * academic, research and internal business purposes only, without a fee.
 * Licensee may distribute the binary and source code (if released) to third
 * parties provided that the copyright notice and this statement appears on
 * all copies and that no charge is associated with such copies.
 *  
 * Licensee may make derivative works.  However, if Licensee distributes any
 * derivative work based on or derived from the Software, then Licensee will
 * (1) notify NCSA regarding its distributing of the derivative work, and (2)
 * clearly notify users that such derivative work is a modified version and
 * not the original NCSA Habanero distributed by the UI.
 *  
 * Any Licensee wishing to make commercial use of the Software should contact
 * the UI, c/o NCSA, to negotiate an appropriate license for such commercial
 * use.  Commercial use included (1) integration of all or part of the
 * Software into a product for sale or license by or on behalf of Licensee to
 * third parties, or (2) distribution of the Software to third parties that
 * need it to utilize a commercial product sold or licensed by or on behalf of
 * Licensee.
 *  
 * UI MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.  THE
 * UI SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY THE USERS OF THIS
 * SOFTWARE.
 *  
 * By using or copying this Software, Licensee agrees to abide by the
 * copyright law and all other applicable laws of the U.S. including, but not
 * limited to, export control laws, and the terms of this license.  UI shall
 * have the right to terminate this license immediately by written notice upon
 * Licensee's breach of, or non-compliance with, any of its terms.  Licensee
 * may be held legally responsible for any copyright infringement that is
 * caused or encouraged by Licensee's failure to abide by the terms of this
 * license.
 * 
 *
 * ----
 * 
 * 
 * U.S. GOVERNMENT RESTRICTED RIGHTS
 * 
 * The Software and/or user documentation are provided with RESTRICTED AND
 * LIMITED RIGHTS.  Use, duplication or disclosure by or to the United States
 * government shall be subject to restrictions as set forth in subparagraph
 * (c)(1)(ii) of Defense Federal Acquisition Regulations Supplement (DFARS)
 * Section 252.227-7013 for Department of Defense contracts and as set forth
 * in Federal Acquisition Regulations (FAR) Section 52.227-19 for civilian
 * agency contracts or any successor regulations.  Contractor/Manufacturer is
 * The Board of Trustees of the University of Illinois, Urbana, Illinois
 * 61801.
 * 
 */
package VotingTool;
import java.awt.*;
import java.io.*;
import java.util.*;

public  class MultiResultPanel extends GridBorderPanel{
	Hashtable PublicData = null;
	Button More = new Button("More");
	Label AccessLabel, DisplayLabel, TopicLabel;
	GridBagLayout gridbag = new GridBagLayout();
	StoppableFrame DataFrame;

  public  MultiResultPanel (MultiBallot InfoB, MultiArbiResult TheResults){
    super("Results");
    
    String SessionOwner;
    int [] ResultA;
    Color [] ColorArray = {Color.green,Color.blue, Color.lightGray, Color.magenta, Color.yellow, Color.pink, Color.orange,Color.black, Color.darkGray, Color.cyan};
    String [] ColorStringArray = {"(green)", "(blue)","(light Gray)","(magenta)","(yellow)","(pink)","(orange)","(black)","(dark Gray)","(cyan)"};
    setLayout(gridbag);

    ResultA = TheResults.Result;
    PieChartCanvas MPC = new PieChartCanvas(150, 25);
    
    constrain(this, new Label("Number of Answers = "+Integer.toString(TheResults.NbVotes)),1,1,2,1);
     if (TheResults.TimerInterrupted)
      constrain(this, new Label("Timer Interruption, Non Voters: "+Integer.toString(TheResults.NbVoters - TheResults.NbVotes)),3,1,2,1);
    constrain(this, new Label("Number of DC = "+Integer.toString(TheResults.NullVotes)+" (red)"),1,2,2,1);
     MPC.addSlice((float)TheResults.NullVotes*250/TheResults.NbVoters, Color.red);

    int lineCpt =1;
    try{
      for (int i=0;i<ResultA.length;i++) 
	{
	  constrain(this, new Label("Proposition #"+i+": "+Integer.toString(ResultA[i])+" "+ColorStringArray[i]),2,lineCpt+3,2,1);
		++lineCpt ;
	  if (i<11)
	   MPC.addSlice((float)ResultA[i]*250/TheResults.NbVoters, ColorArray[i]);
	}
    }
	    catch (NoSuchElementException nse){
	      System.out.println("MultiVoting doEvent Hashtable: toString()"+ResultA.toString());
	      }
    constrain(this,More,4,lineCpt+5,2,1);
    if (!InfoB.Public())  More.disable();
    constrain(this, MPC, 5, 2, 5,6);
    PublicData = TheResults.DatatoTransmit;
    
  }
protected  void finalize(){
    DataFrame.hide();}
	
	public void show_PublicData(){
	  int [] RA;
	  int lineCpt =1;
	  
	  Button OK;
	   DataFrame = new StoppableFrame();
	  GridPanel DataPanel = new GridPanel();
	  
	  DataPanel.setLayout(gridbag);
	
      	  DataFrame.add("Center", DataPanel);
	  constrain(DataPanel, new Label("Voter ID:"),0,0,1,1);
     constrain(DataPanel, new Label("Vote:"),1,0,1,1);
	  
	  for (Enumeration Part = PublicData.keys();Part.hasMoreElements();) 
	    {
	      String Nom =(String) Part.nextElement();
	      DataPanel.constrain(DataPanel, new Label(Nom+": "),0,lineCpt,1,1);
	      try{
		RA = (int []) PublicData.get(Nom);
		DataPanel.constrain(DataPanel, new Label(FlatLine(RA)),1,lineCpt,1,1);
	      }
	      catch (ClassCastException cce){
		DataPanel.constrain(DataPanel, new Label("Don't Care"),1,lineCpt,1,1);
		}
	      ++lineCpt ;
	    }
	   DataFrame.pack();
	  DataFrame.setTitle("More Info");

	  DataFrame.show();
	  
	}
	public String FlatLine (int [] RA){
	  String Chaine;
	  if (RA.length == 0) {
	    Chaine = "Information lost"; 
	    return Chaine;
	  }
	  Chaine = "Answers: #"+(new Integer(RA[0])).toString();
	  for (int i=1; i<RA.length; i++) Chaine += "#"+(new Integer(RA[i])).toString()+" ";
	  return Chaine;
	}
	
   	public boolean handleEvent(Event e) {
	  
	  switch (e.id){
	  case Event.ACTION_EVENT:
	    if (e.target instanceof Button){
	      String label=(String)e.arg;
	      if (label.equals("More")) {
		if (PublicData!=null) {
		  show_PublicData();
		  More.disable();
		}
	      }
	    }
	    
	  }
	  return true;
	}
      }


