
/*
 * NCSA Habanero Project
 * Software Development Group
 * National Center for Supercomputing Applications
 * University of Illinois at Urbana-Champaign
 * 605 E. Springfield, Champaign, IL 61820
 *  
 * info@havefun.ncsa.uiuc.edu
 *  
 * Copyright 1995-1996, Board of Trustees of the University of Illinois, 
 * All Rights Reserved
 *  
 * NCSA Habanero software, binary, Java-bytecode, and source (hereafter,
 * Software) is copyrighted by The Board of Trustees of the University of
 * Illinois (UI), and ownership remains with the UI.
 *  
 * The UI grants you (hereafter, Licensee) a license to use the Software for
 * academic, research and internal business purposes only, without a fee.
 * Licensee may distribute the binary and source code (if released) to third
 * parties provided that the copyright notice and this statement appears on
 * all copies and that no charge is associated with such copies.
 *  
 * Licensee may make derivative works.  However, if Licensee distributes any
 * derivative work based on or derived from the Software, then Licensee will
 * (1) notify NCSA regarding its distributing of the derivative work, and (2)
 * clearly notify users that such derivative work is a modified version and
 * not the original NCSA Habanero distributed by the UI.
 *  
 * Any Licensee wishing to make commercial use of the Software should contact
 * the UI, c/o NCSA, to negotiate an appropriate license for such commercial
 * use.  Commercial use included (1) integration of all or part of the
 * Software into a product for sale or license by or on behalf of Licensee to
 * third parties, or (2) distribution of the Software to third parties that
 * need it to utilize a commercial product sold or licensed by or on behalf of
 * Licensee.
 *  
 * UI MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.  THE
 * UI SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY THE USERS OF THIS
 * SOFTWARE.
 *  
 * By using or copying this Software, Licensee agrees to abide by the
 * copyright law and all other applicable laws of the U.S. including, but not
 * limited to, export control laws, and the terms of this license.  UI shall
 * have the right to terminate this license immediately by written notice upon
 * Licensee's breach of, or non-compliance with, any of its terms.  Licensee
 * may be held legally responsible for any copyright infringement that is
 * caused or encouraged by Licensee's failure to abide by the terms of this
 * license.
 * 
 *
 * ----
 * 
 * 
 * U.S. GOVERNMENT RESTRICTED RIGHTS
 * 
 * The Software and/or user documentation are provided with RESTRICTED AND
 * LIMITED RIGHTS.  Use, duplication or disclosure by or to the United States
 * government shall be subject to restrictions as set forth in subparagraph
 * (c)(1)(ii) of Defense Federal Acquisition Regulations Supplement (DFARS)
 * Section 252.227-7013 for Department of Defense contracts and as set forth
 * in Federal Acquisition Regulations (FAR) Section 52.227-19 for civilian
 * agency contracts or any successor regulations.  Contractor/Manufacturer is
 * The Board of Trustees of the University of Illinois, Urbana, Illinois
 * 61801.
 * 
 */

package VotingTool;

import java.awt.*;
import java.io.*;
import ncsa.habanero.*;
import VotingTool.*;

public class VotingTool extends Panel implements ncsa.habanero.Wrapped, ncsa.habanero.Initializable{
String WhoIAm;
InitVote InitPanel = null;
Panel WaitPanel;
ActiveGridPanel Bench = null;
boolean VotingSessionInitializing = true;
MirrorFrame fprime;
boolean VoteEnded = false;

public VotingTool(){
}
public String SessionOwner(){
  
  if (fprime !=null){
    return fprime.getCollobject().originator().getName();
   }
  else {
    System.out.println("No Tool Manager available!");
    return null;
   }
   }

public void startInFrame(MirrorFrame f){
 // System.out.println("Start In Frame: VotingToo");
  WhoIAm = SessionManager.manager().owner().unique();
  //SessionOwner = f.getCollobject().originator().getName();
  //f.setLayout(new BorderLayout());
  fprime = f;
  f.setBackground(Color.white);
  this.setFont(new Font("Courier",Font.ITALIC,14));
 
    
 if (VoteEnded){
    //f.resize(10,10);
    f.hide();
    return;
    }
    /*else{
      WaitPanel = new Panel();
      Label l = new Label("a Vote Session is being Initialized");
      WaitPanel.add(l);
      add(WaitPanel);
      f.add("Center", this);
      f.setTitle("Initiate a Vote Session: Owner "+SessionOwner);
      f.pack();
      }*/

  if (Bench != null){ 
    this.removeAll();
    add(Bench);
  
   }
   f.add("Center", this);
  f.pack();
}

public boolean isInitialized(){
  return (!VotingSessionInitializing);
   }
public  void queryForParameters(Collobject c){
  InitPanel = new InitVote(WhoIAm);
  this.add(InitPanel);
  //fprime.add("Center", this);
  this.layout();
  //fprime.setLayout(new FlowLayout( FlowLayout.LEFT));
  fprime.setTitle("Initiate a Vote Session: Owner "+WhoIAm);
  VotingSessionInitializing = false;
  fprime.layout(); 
   fprime.pack();
   fprime.show();
}


public boolean doEvent(Event e, Object arg){
 
  //System.out.println("VotingTool: doEvent: "+arg);
    if (arg instanceof SimpleBallot){
      SimpleBallot SB = (SimpleBallot)arg;
      Bench = new SimpleVoting(SB);
      fprime.setTitle("Simple Vote Session: Owner "+SessionOwner()); 
    }
    else if (arg instanceof PropBallot){
      PropBallot PB = (PropBallot)arg;
      Bench = new PropVoting(PB);
      fprime.setTitle("Proportionnal Vote Session: Owner "+SessionOwner());
    }
    else if (arg instanceof MultiBallot){
      MultiBallot MB = (MultiBallot)arg;
      Bench = new MultiVoting(MB);
      fprime.setTitle("Quizz Vote Session: Owner "+SessionOwner());
    }
    else if ((arg instanceof SimpleArbiResult)||(arg instanceof PropArbiResult )||(arg instanceof MultiArbiResult)) {
      VoteEnded = true;
      Bench.doEvent(e, arg);
      fprime.setTitle("Vote Session: Results");
    }
    else return true;

    Bench.layout();
    this.removeAll();
    this.add(Bench);
    this.layout();
    VotingSessionInitializing = false;
    fprime.layout();
    fprime.pack();
    fprime.show();
   
  return true;
}
/*
   public boolean handleEvent(Event e){
   if (e.id == Event.ACTION_EVENT){
   try {
   String Mesg = (String) e.arg ;
   if (Mesg.equals("Cancel")){
   e.id = HabaneroEvent.QUIT_APP;
   return false;
   }
   }
   catch (java.lang.ClassCastException cce) {
   return false;
   }
   }
   return false;
   }
*/
public void MarshallSelf(DataOutput out) throws IOException {
  out.writeBoolean(VoteEnded);
if (!VoteEnded){
  //out.writeBoolean(VotingSessionInitializing);
  if (Bench== null) {
    out.writeUTF("Null");
 }else{
   out.writeUTF("Non Null");
   Marshalling.marshallSomething(Bench, out);
 }
}

}
public void UnmarshallSelf(DataInput in) throws IOException {
 // System.out.println("UnMarshallSelf: Voting Tool");
VoteEnded = in.readBoolean();
if (!VoteEnded){
  //VotingSessionInitializing=in.readBoolean();
  if (in.readUTF().equals("Null")){}
  else {
    Bench = (ActiveGridPanel) Marshalling.Unmarshall(in);
  }
}
}
}


